uniform mat4 projectionMatrix;
uniform mat4 modelviewMatrix;
uniform vec3 wind;
attribute vec3 aPosition;
attribute vec2 aTexcoord;
attribute vec4 aColor;
attribute vec3 aNormal;
varying vec3 vPosition;
varying vec3 vNormal;
varying vec2 vTexcoord;
varying vec3 vColor;

void main()
{
	vPosition = (modelviewMatrix*vec4(aPosition, 1.0)).xyz;
	vNormal = (modelviewMatrix*vec4(aNormal, 0.0)).xyz;
	
	vColor = vec3(0.0,0.0,0.3) + abs(vNormal.z);
	vTexcoord = aTexcoord;
    gl_Position = projectionMatrix*vec4(vPosition, 1.0);
}
